<?php

/*For Sidebar Widget*/

if ( function_exists('register_sidebar') )

register_sidebar(array(

'name' => 'sidebar',

'before_widget' => '<div class="sidebar-box">',

'after_widget' => '</div>',

'before_title' => '<h2>',

'after_title' => '</h2>',

));

/*End of For Sidebar Widget*/


/*Breadcrumbs*/

function the_breadcrumb() {

	echo 'You are here: ';

	if (!is_home()) {

		echo '<a name="interesting-posts" href="';

		echo get_option('home');

		echo '">';

		echo 'Home';

		echo "</a> &raquo; ";

		if (is_category() || is_single()) {

			if (is_single()) {

				echo the_title();

			}

		} elseif (is_page()) {

			echo the_title();

		}

		elseif (is_tag()) {

			single_tag_title();

		}

		elseif (is_day()) {

			echo "Archive for "; the_time('F jS, Y');

		}

		elseif (is_month()) {

			echo "Archive for "; the_time('F, Y');

		}

		elseif (is_year()) {

			echo "Archive for "; the_time('Y');

		}

		elseif (is_author()) {

			echo "Author Archive";

		}

		elseif (isset($_GET['paged']) && !empty($_GET['paged'])) {

			echo "Blog Archives";

		}

		elseif (is_search()) {

			echo "Search Results";

		}

		elseif (is_404()) {

			echo "404 Error";

		}

	}else{

		echo '<a name="interesting-posts" href="';

		echo get_option('home');

		echo '">';

		echo 'Home';

		echo "</a>";

	}

}

/*End of Breadcrumbs*/


/*For Popular Posts*/
function most_popular_posts($no_posts = 4, $before = '<li class="special-li">', $after = '</li>', $show_pass_post = false, $duration='') {
	global $wpdb;
	$request = "SELECT ID, post_title, COUNT($wpdb->comments.comment_post_ID) AS 'comment_count' FROM $wpdb->posts, $wpdb->comments";
	$request .= " WHERE comment_approved = '1' AND $wpdb->posts.ID=$wpdb->comments.comment_post_ID AND post_status = 'publish'";
	if(!$show_pass_post) $request .= " AND post_password =''";
	if($duration !="") { $request .= " AND DATE_SUB(CURDATE(),INTERVAL ".$duration." DAY) < post_date ";
	}
	$request .= " GROUP BY $wpdb->comments.comment_post_ID ORDER BY comment_count DESC LIMIT $no_posts";
	$posts = $wpdb->get_results($request);
	$output = '';
	if ($posts) {
		foreach ($posts as $post) {
		$post_title = stripslashes($post->post_title);
		$comment_count = $post->comment_count;
		$permalink = get_permalink($post->ID);
		$output .= $before . '<a href="' . $permalink . '" title="' . $post_title.'">' . $post_title . '</a><br/>There are ' . $comment_count.' comments to this post'. $after;
	}
	} else {
		$output .= $before . "None found" . $after;
	}
	echo $output;
}
/*End of Popular Posts*/


/*Fix Excerpts*/

function wp_improved_trim_excerpt($text) {

	global $post;

	if ( '' == $text ) {

		$text = get_the_content('');

		$text = apply_filters('the_content', $text);

		$text = str_replace(']]>', ']]&gt;', $text);

		$text = strip_tags($text);

		$excerpt_length = 50;

		$words = explode(' ', $text, $excerpt_length + 1);

		if (count($words)> $excerpt_length) {

			array_pop($words);

			array_push($words, '...');

			$text = implode(' ', $words);

		}

	}

	return $text;

}

remove_filter('get_the_excerpt', 'wp_trim_excerpt');

add_filter('get_the_excerpt', 'wp_improved_trim_excerpt');

/*End of Fix Excerpts*/



/*Custom Field Images*/

function image_attachment($key, $width, $height) {

	global $post;

	$custom_field = get_post_meta($post->ID, $key, true);



	if($custom_field) {

		echo '<img src="'.$custom_field.'" alt="Post Image" width="'.$width.'" height="'.$height.'" />';

	}

	else {

		return;

	}

}

/*End of Custom Field Images*/



/*Start of Theme Options ======================================*/



$themename = "Rock Solid";

$shortname = "rs";

$options = array (



array(  "name" => "Rock Solid Options",
        "type" => "title"),

array(  "type" => "open"),

array(  "name" => "Pick a Color",
        "desc" => "Choose which color scheme you want your website to have.",
        "id" => $shortname."_color_selection",
        "std" => "blue",
        "type" => "select",
		"options" => array("red","blue","green","gray")),

array(  "name" => "Post Image Key",
        "desc" => "If you were using a theme before this one where the image thumbnail key was something different than 'image', input the name of that key here so Rock Solid can retrieve your pictures.  <strong>Warning:</strong> they may be stretched if they are not 512px x 200px.",
        "id" => $shortname."_image_key",
        "type" => "text",
        "std" => "image"),	

array(    "name" => "Display Twitter Widget?",
        "desc" => "Check this box to show the Twitter widget in the sidebar.  If it's active, be sure to put in your Twitter name in the field below.",
        "id" => $shortname."_show_twitter",
        "type" => "checkbox",
		"std" => "false"),
		
array(    "name" => "Twitter Name",
        "desc" => "If you have the Twitter widget activated, input your Twitter name here so Rock Solid can retrieve your Tweets.",
        "id" => $shortname."_twitter_name",
		"std" => "",
        "type" => "text"),
		
array(    "name" => "Tweet Count",
        "desc" => "How many of your latest tweets would you like to show?  The default is 3.",
        "id" => $shortname."_twitter_number_tweets",
		"std" => "3",
        "type" => "text"),
		
array(  "name" => "Display Flickr Photostream?",
        "desc" => "Check this box to show the Flickr photostream at the bottom of the website.  If this is active, be sure you have uploaded, activated, and input your Flickr ID into the FlickrRSS plugin that is included in this theme.",
        "id" => $shortname."_show_flickr",
        "type" => "checkbox",
        "std" => "false"),
		
array(  "name" => "Display Google Adsense in Header?",
        "desc" => "Check this box to show Google Adsense ads in the header.  Make sure if you have this checked that you have also entered your Google pub-id in the field below.",
        "id" => $shortname."_show_adsense_header",
        "type" => "checkbox",
        "std" => "false"),
		
array(  "name" => "Display Google Adsense Above Posts?",
        "desc" => "Check this box to show Google Adsense ads above posts.  Make sure if you have this checked that you have also entered your Google pub-id in the field below.",
        "id" => $shortname."_show_adsense_posts",
        "type" => "checkbox",
        "std" => "false"),
		
array(  "name" => "What is Your Google Adsense Pub-ID?",
        "desc" => "Only bother with this if you are showing Google ads on your site.  Enter your publisher ID number (minus the 'pub-').",
        "id" => $shortname."_adsense_id",
        "type" => "text",
        "std" => ""),
		
array(  "name" => "Enable the 125px x 125px Ad Area Above Posts?",
        "desc" => "If you'll be using 125px x 125px ads on the site, check this box then fill in the fields below.  You can show a max of 4 ads at once.",
        "id" => $shortname."_show_125ads",
        "type" => "checkbox",
        "std" => "false"),
		
array(  "name" => "125px x 125px Ad Number 1 Image.",
        "desc" => "Insert the image code for the first ad here.  Note, there is a default 'Advertise Here' image in this themes '/images/' folder, you can link to that if you have no ads to display.",
        "id" => $shortname."_show_125ad_1_image",
        "type" => "text",
        "std" => ""),
		
array(  "name" => "125px x 125px Ad Number 1 Link.",
        "desc" => "Insert the link to where the image you defined above goes to.",
        "id" => $shortname."_show_125ad_1_link",
        "type" => "text",
        "std" => ""),
		
array(  "name" => "125px x 125px Ad Number 2 Image.",
        "desc" => "Insert the image code for the second ad here.  Note, there is a default 'Advertise Here' image in this themes '/images/' folder, you can link to that if you have no ads to display.",
        "id" => $shortname."_show_125ad_2_image",
        "type" => "text",
        "std" => ""),
		
array(  "name" => "125px x 125px Ad Number 2 Link.",
        "desc" => "Insert the link to where the image you defined above goes to.",
        "id" => $shortname."_show_125ad_2_link",
        "type" => "text",
        "std" => ""),
		
array(  "name" => "125px x 125px Ad Number 3 Image.",
        "desc" => "Insert the image code for the third ad here.  Note, there is a default 'Advertise Here' image in this themes '/images/' folder, you can link to that if you have no ads to display.",
        "id" => $shortname."_show_125ad_3_image",
        "type" => "text",
        "std" => ""),
		
array(  "name" => "125px x 125px Ad Number 3 Link.",
        "desc" => "Insert the link to where the image you defined above goes to.",
        "id" => $shortname."_show_125ad_3_link",
        "type" => "text",
        "std" => ""),
		
array(  "name" => "125px x 125px Ad Number 4 Image.",
        "desc" => "Insert the image code for the fourth ad here.  Note, there is a default 'Advertise Here' image in this themes '/images/' folder, you can link to that if you have no ads to display.",
        "id" => $shortname."_show_125ad_4_image",
        "type" => "text",
        "std" => ""),

array(  "name" => "125px x 125px Ad Number 4 Link.",
        "desc" => "Insert the link to where the image you defined above goes to.",
        "id" => $shortname."_show_125ad_4_link",
        "type" => "text",
        "std" => ""),		
		
array(    "type" => "close")

);



/*Add a Theme Options Page*/
function mytheme_add_admin() {

    global $themename, $shortname, $options;

    if ( $_GET['page'] == basename(__FILE__) ) {

        if ( 'save' == $_REQUEST['action'] ) {

                foreach ($options as $value) {
                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

                foreach ($options as $value) {
                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

                header("Location: themes.php?page=functions.php&saved=true");
                die;

        } else if( 'reset' == $_REQUEST['action'] ) {

            foreach ($options as $value) {
                delete_option( $value['id'] ); }

            header("Location: themes.php?page=functions.php&reset=true");
            die;

        }
    }

    add_theme_page($themename." Options", "".$themename." Options", 'edit_themes', basename(__FILE__), 'mytheme_admin');

}

function mytheme_admin() {

    global $themename, $shortname, $options;

    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';

?>
<div class="wrap">
<h2><?php echo $themename; ?> Settings</h2>

<form method="post">

<?php foreach ($options as $value) {
switch ( $value['type'] ) {

case "open":
?>
<table width="100%" border="0" style="background-color:#eef5fb; padding:10px;">

<?php break;

case "close":
?>

</table><br />

<?php break;

case "title":
?>
<table width="100%" border="0" style="background-color:#dceefc; padding:5px 10px;"><tr>
    <td colspan="2"><h3 style="font-family:Georgia,'Times New Roman',Times,serif;"><?php echo $value['name']; ?></h3></td>
</tr>

<?php break;

case 'text':
?>

<tr>
    <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
    <td width="80%"><input style="width:400px;" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" /></td>
</tr>

<tr>
    <td><small><?php echo $value['desc']; ?></small></td>
</tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>

<?php
break;

case 'textarea':
?>

<tr>
    <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
    <td width="80%"><textarea name="<?php echo $value['id']; ?>" style="width:400px; height:200px;" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?></textarea></td>

</tr>

<tr>
    <td><small><?php echo $value['desc']; ?></small></td>
</tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>

<?php
break;

case 'select':
?>
<tr>
    <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
    <td width="80%"><select style="width:240px;" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>"><?php foreach ($value['options'] as $option) { ?><option<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; } elseif ($option == $value['std']) { echo ' selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?></select></td>
</tr>

<tr>
    <td><small><?php echo $value['desc']; ?></small></td>
</tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>

<?php
break;

case "checkbox":
?>
    <tr>
    <td width="20%" rowspan="2" valign="middle"><strong><?php echo $value['name']; ?></strong></td>
        <td width="80%"><?php if(get_option($value['id'])){ $checked = "checked=\"checked\""; }else{ $checked = "";} ?>
                <input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />
                </td>
    </tr>
	
    <tr>
        <td><small><?php echo $value['desc']; ?></small></td>
   </tr><tr><td colspan="2" style="margin-bottom:5px;border-bottom:1px dotted #000000;">&nbsp;</td></tr><tr><td colspan="2">&nbsp;</td></tr>

<?php         break;

}
}
?>

<p class="submit">
<input name="save" type="submit" value="Save changes" />
<input type="hidden" name="action" value="save" />
</p>
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>

<?php
}

add_action('admin_menu', 'mytheme_add_admin');
/*End of Add a Theme Options Page*/

/*End of Theme Options =======================================*/
?>